<master>
<property name="doc(title)">@page_title;literal@</property>
<property name="main_navbar_label">timesheet2_timesheet</property>
<property name="left_navbar">@left_navbar_html;literal@</property>


<div id=@task_editor_id@>
<script type='text/javascript' <if @::__csp_nonce@ not nil>nonce="@::__csp_nonce;literal@"</if>>


// Ext.Loader.setConfig({enabled: true});
Ext.Loader.setPath('PO', '/sencha-core');
Ext.Loader.setPath('PO.model', '/sencha-core/model');
Ext.Loader.setPath('PO.store', '/sencha-core/store');
Ext.Loader.setPath('PO.class', '/sencha-core/class');
Ext.Loader.setPath('Ext.ux', '/sencha-core/ux');
Ext.Loader.setPath('PO.view', '/sencha-core/view');
Ext.Loader.setPath('PO.controller', '/sencha-core/controller');
Ext.Loader.setPath('PO.tsweekly', '/intranet-timesheet2-weekly/js');

// Disable the ?_dc=123456789 parameter from loader
Ext.Loader.setConfig({disableCaching: false});

Ext.require([
    'Ext.data.*',
    'Ext.grid.*',
    'Ext.tree.*',
    'PO.Utilities',
    'PO.store.CategoryStore',
    'PO.store.project.ProjectMainStore',
    'PO.controller.StoreLoadCoordinator',
    'PO.model.timesheet.TimesheetTask',
    'PO.model.timesheet.Hour',
    'PO.model.project.Project',
    'PO.store.timesheet.HourStore',
    'PO.store.timesheet.TaskTreeStore',
    'PO.view.field.POComboTree'
]);

// Global parameters from server-side
var default_material_id = parseInt('@default_material_id@');			// "Default" material
var default_cost_center_id = parseInt('@default_cost_center_id@');		// "The Company" cost-center
var default_uom_id = parseInt('@default_uom_id@');				// "Hour" default Unit of Measure
var default_effort_driven_type_id = parseInt('@default_effort_driven_type_id@'); // "Fixed Effort" as default



function launchTimesheetWeeklyLogging(){

    // -----------------------------------------------------------------------
    // Stores
    var hourStore = Ext.StoreManager.get('hourStore');
    var taskTreeStore = Ext.StoreManager.get('taskTreeStore');
    var projectStore = Ext.StoreManager.get('projectMainStore');

    // Row-Editor for the hour grid
    var rowEditing = Ext.create('Ext.grid.plugin.RowEditing', {
        clicksToEdit: 1,
        clicksToMoveEditor: 1,
        listeners: {
            edit: function(editor, context, eOpts) {
                // Check that the endTime is later than startTime
                context.record.save();
            }
        }
    });

    // Cell-Editor for the hour grid
    var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {
        clicksToEdit: 1,
        clicksToMoveEditor: 1,
        listeners: {
            edit: function(editor, context, eOpts) {
                // Check that the endTime is later than startTime
                context.record.save();
            }
        }
    });

    var sumType = function(hourArray, dataIndex) {
        var sum = 0;
        for (var i = 0; i < hourArray.length; i++) {
            var vString = hourArray[i].get(dataIndex);
            var vFloat = parseFloat(vString);
            if (!!vFloat) sum = sum + vFloat;
        }
        return sum;
    };

    var sumRenderer = function(value, summaryData, dataIndex) {
        var type = typeof(value);
        if ("number" == type) {
            return Math.round(value * 100) / 100;
        }
        return value;
    };
    
    var hourGrid = Ext.create('Ext.grid.Panel', {
        store: hourStore,
        layout: 'fit',
        region: 'center',
        columnLines: true,
        enableLocking: true,
        collapsible: false,
        title: 'Expander Rows in a Collapsible Grid with lockable columns',
        header: false,
        emptyText: 'No data yet - please click on one of the tasks at the left',
        iconCls: 'icon-grid',
        margin: '0 0 20 0',
        plugins: [rowEditing],
        features: [{
            ftype: 'summary',
            dock: 'bottom'
        }],

        // reference to controller
        hourController: null,		// Reference to main controller
        columns: [
            {
                text: 'Project',
                flex: 1,
                dataIndex: 'main_project_id',
                renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                    var main_project_id = record.get('main_project_id');
                    var projectModel = projectStore.getById(main_project_id);
                    if (!projectModel) return "";
                    return projectModel.get('project_name');
                },
                editor: {
                    xtype: 'combo',
                    queryMode: 'local',
                    store: projectStore,
                    displayField: 'project_name',
                    valueField: 'project_id',
                    matchFieldWidth: false,
                    displayTpl: Ext.create('Ext.XTemplate', '<tpl for=".">', '{project_name}', '</tpl>'),
                    listeners: {
                        change: function(combo, value, oldValue, event) {
                            // ToDo: Replace this hard-wired reference with something more intelligent
                            var controller = hourGrid.hourController;
                            controller.onProjectChanged(value, combo, hourGrid);
                        }
                    }
                }
            }, {
                text: 'Task',
                flex: 1,
                dataIndex: 'project_id',
                renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                    var taskName = record.get('project_id_deref');
                    if (!!taskName && "" != taskName) return taskName;
                    var taskModel = taskTreeStore.getById(value);
                    if (!taskModel) return "";
                    return taskModel.get('project_name');
                },
                editor: { xtype: 'pocombotree', store: taskTreeStore, queryMode: 'local', displayField: 'project_name', valueField: 'id'}
            },
            // { text: "Date", xtype: 'datecolumn', dataIndex: 'day', renderer: Ext.util.Format.dateRenderer('Y-m-d'), editor: {xtype: 'datefield',allowBlank: true}},
            {text: "<div align=center>Mon<br>3/29/2021</div>", width: 75, align: "right", dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Tue<br>3/30/2021</div>", width: 75, align: "right", dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Wed<br>2/31/2021</div>", width: 75, align: "right", dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Thu<br>2/31/2021</div>", width: 75, align: "right", dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Fri<br>2/31/2021</div>", width: 75, align: "right", dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Sat<br>2/31/2021</div>", width: 75, align: "right", dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Sun<br>2/31/2021</div>", width: 75, align: "right", dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            { text: "Sum", width: 75, dataIndex: 'note', align: "center",
              renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                  var hoursString = record.get('hours');
                  var hoursFloat = parseFloat(hoursString)
                  if ("number" == typeof(hoursFloat)) return Math.round(700.0 * hoursFloat) / 100.0;
                  return "";
              },
              summaryType: function(hourArray, dataIndex) {
                  var sum = 0;
                  for (var i = 0; i < hourArray.length; i++) {
                      var vString = hourArray[i].get("hours");
                      var vFloat = parseFloat(vString);
                      if (!!vFloat) sum = sum + vFloat;
                  }
                  return sum;
              },
              summaryRenderer: function(value, summaryData, dataIndex) {
                  var type = typeof(value);
                  if ("number" == type) {
                      return Math.round(7.0 * value * 100) / 100;
                  }
                  return value;
              }
            }
            // { text: "Note", flex: 1, dataIndex: 'note', editor: { allowBlank: true }}
        ]
    });

    // -----------------------------------------------------------------------
    // Outer panel joining the two parts (Buttons + Grid)
    var screenSize = Ext.getBody().getViewSize();    // Size calculation based on specific ]po[ layout
    var sideBarSize = Ext.get('sidebar').getSize();
    var width = screenSize.width - sideBarSize.width - 95;
    var height = screenSize.height - 280;

    Ext.define('PO.view.timesheet.HourWeeklyButtonPanel', {
        extend: 'Ext.panel.Panel',
        alias: 'ganttButtonPanel',
        width: 900,
        height: 500,
        layout: 'border',
        defaults: {
            collapsible: true,
            split: true,
            bodyPadding: 0
        },
        tbar: [
            {
                icon: '/intranet/images/navbar_default/add.png',
                tooltip: '<%= [lang::message::lookup "" intranet-timesheet2-weekly.Manual_logging "Manual logging"] %>',
                id: 'buttonAddEntry',
                disabled: false
            }, {
                icon: '/intranet/images/navbar_default/delete.png',
                tooltip: '<%= [lang::message::lookup "" intranet-timesheet2-weekly.Delete_logging "Delete entry"] %>',
                id: 'buttonDeleteEntry',
                disabled: false
            }, {
                xtype: 'tbseparator'
            }, {
                xtype: 'datefield',
                // anchor: '100%',
                // fieldLabel: 'From',
                name: 'from_date',
                value: new Date(),
                maxValue: new Date(),
                format: "Y-W",
                startDay: 1
            }
        ]
    });

    // Use the button panel as a container for the task tree and the hour grid
    var hourButtonPanel = Ext.create('PO.view.timesheet.HourWeeklyButtonPanel', {
        renderTo: '@task_editor_id@',
        width: width,
        height: height,
        resizable: true,					// Add handles to the panel, so the user can change size
        items: [
            hourGrid
        ]
    });

    var sideBarTab = Ext.get('sideBarTab');
    var hourController = Ext.create('PO.tsweekly.HourWeeklyController', {
        'hourButtonPanel': hourButtonPanel,
        'hourController': hourController,
        'hourGrid': hourGrid
    });
    hourController.init(this).onLaunch(this);
    hourGrid.hourController = hourController;   // Add reference to hourGrid
    
    // Testing events
    hourButtonPanel.fireEvent('keypress');

    // -----------------------------------------------------------------------
    // Handle collapsable side menu
    sideBarTab.on('click', hourController.onSideBarResize, hourController);
    Ext.EventManager.onWindowResize(hourController.onWindowsResize, hourController);    // Deal with resizing the main window
};


var debugHash = @debug_json;noquote@;
function getDebug(id) {
    // Check for a debug setting for the specific Id
    var debug = parseInt(debugHash[id]);
    if (!isNaN(debug)) return debug;

    // Use the default debug
    debug = parseInt(debugHash['default']);
    if (!isNaN(debug)) return debug;

    // invalid configuration - enable debug
    return 1;
};

// -----------------------------------------------------------------------
// Start the application after loading the necessary stores
//
Ext.onReady(function() {
    Ext.QuickTips.init();
    var debug = getDebug('default');
    var taskTreeStore = Ext.create('PO.store.timesheet.TaskTreeStore');
    var hourStore = Ext.create('PO.store.timesheet.HourStore');
    var projectStore = Ext.create('PO.store.project.ProjectMainStore');

    // Use a "store coodinator" in order to launchTimesheetWeeklyLogging() only
    // if all stores have been loaded:
    var coordinator = Ext.create('PO.controller.StoreLoadCoordinator', {
        stores: [
            'hourStore', 
//            'taskTreeStore',
            'projectMainStore'
        ],
        listeners: {
            load: function() {
                if ("boolean" == typeof this.loadedP) { return; }
                launchTimesheetWeeklyLogging();
                this.loadedP = true;
            }
        }
    });

    // Load stores that need parameters
    taskTreeStore.getProxy().extraParams = { project_id: 18228 };
    taskTreeStore.load({
        callback: function(records, operation, success) {
            var me = this;
            if (debug) console.log('PO.store.timesheet.TaskTreeStore: loaded');
            if (!success) {
                PO.Utilities.reportStoreError("TaskTreeStore", operation);
                return;
            }
            var mainProjectNode = records[0];
            mainProjectNode.set('sort_order','0');
            me.setRootNode(mainProjectNode);
        }
    });

    // Load stores that need parameters
    hourStore.getProxy().extraParams = { query: "user_id = @current_user_id@ and day > '2021-03-10'", format: 'json', deref_p: 1 };
    hourStore.load({
        callback: function() {
            console.log('PO.store.timesheet.HourStore: loaded');
        }
    });

    // Load stores that need parameters
    // projectStore.getProxy().extraParams = { query: 'parent_id is NULL and project_status_id = 76', format: 'json' };
    projectStore.getProxy().extraParams = { query: 'parent_id is NULL and (project_status_id in (select * from im_sub_categories(76)) OR \
parent_id is null)', format: 'json' };
    projectStore.load({
        callback: function() {
            console.log('PO.store.project.ProjectMainStore: loaded');
        }
    });
});
</script>
</div>


